variables:
  DOCKER_HOST: tcp://bytekode-docker:2375/
  DOCKER_DRIVER: overlay2

# Hidden job for reference with other job
.docker-build: &docker-build
  tags: 
    - docker-itsd-noproxy
  image: docker:latest
  services:
    - bytekode/docker:dind
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    untracked: true
    policy: pull-push
  script:
    - |
        docker build \
          -t ${CI_PROJECT_NAME}:${CI_PIPELINE_ID} \
          .

# Build docker image ( Just compile Dockerfile)
build-docker:
  <<: *docker-build
  stage: build-image
  only:
    - master
    - develop
    - /^feature[\/\-].+$/
    - /^hotfix[\/\-].+$/

# Release docker image ( Build & push to registry)
release-docker: 
  # <<: *docker-build
  extends: .docker-build
  stage: release
  only:
    - /^sit[\/\-].+$/
    - /^qa[\/\-].+$/
    - /^prod[\/\-][\d]+(\.\d+){0,3}$/
  
  variables: 
    REQUIRED_VARIABLES: "DOCKER_REGISTRY DOCKER_REGISTRY_USERNAME DOCKER_REGISTRY_PASSWORD DOCKER_REGISTRY_PROJECT"
  before_script:
    # Checking required parameter 
    - | 
        \
        for RVAR in $REQUIRED_VARIABLES
        do
          eval "VAL=\$$RVAR"
          if [[ -z "$VAL" ]]; then MISSVAR="$MISSVAR$RVAR"; fi
        done

        if [[ ! -z $MISSVAR ]]; then
          echo -e "\nFollowing variables are requires.\nPlease config in your gitlab variables.\n---\n$MISSVAR\n---\n\n"  >> /dev/stderr
          exit 1
        fi
    # Login docker registry
    - echo ${DOCKER_REGISTRY_PASSWORD} | docker login ${DOCKER_REGISTRY} -u ${DOCKER_REGISTRY_USERNAME} --password-stdin

  after_script:
    # Create docker tag from branch
    #   - prod/x.x.x.x or v-x.x.x.x  -->  x.x.x.x
    #   - other ${CI_COMMIT_REF_SLUG}
    - |
        DOCKER_TAG=${CI_COMMIT_REF_SLUG}-${CI_PIPELINE_ID} && \
        CATEGORY=$(echo ${CI_COMMIT_REF_NAME} | awk -F '[/-]' '{print $1}')  && \
        if [[ "prod" == "$CATEGORY" ]]; then 
          DOCKER_TAG=$(echo ${CI_COMMIT_REF_NAME} | awk -F '[/-]' '{print $2}')-${CI_PIPELINE_ID}; 
        fi
    # Tag image to new name
    - docker tag ${CI_PROJECT_NAME}:${CI_PIPELINE_ID} ${DOCKER_REGISTRY}/${DOCKER_REGISTRY_PROJECT}/${CI_PROJECT_NAME}:${DOCKER_TAG}
    - docker push ${DOCKER_REGISTRY}/${DOCKER_REGISTRY_PROJECT}/${CI_PROJECT_NAME}:${DOCKER_TAG}
    - echo -e "\n[SUCCESS] Image successful pushed. \n${DOCKER_REGISTRY}/${DOCKER_REGISTRY_PROJECT}/${CI_PROJECT_NAME}:${DOCKER_TAG}\n"
    - docker logout ${DOCKER_REGISTRY}
    - | 
        \
        mkdir -p build && \
        echo "DOCKER_IMAGE=${DOCKER_REGISTRY}/${DOCKER_REGISTRY_PROJECT}/${CI_PROJECT_NAME}:${DOCKER_TAG}" > build/pipeline-variables
  